# generate O from X and W
X=matrix( c( 0,4, 0,0, 3,0, 3,4, 1.5,2 ), ,2, byrow=1 )
dimnames(X)=list(paste("s",1:nrow(X),sep=""), paste("d",1:ncol(X), sep=""))
X=standard( X, center=1 )
W=matrix( c( 1,1, 2,1, 1,2 ),,2, byrow=1 )
rownames(W)=paste("sbj",1:nrow(W),sep=""); colnames(W)=colnames(X)
resgen=gendatamds( X=X, W=W, stderror=0.05, print=2 )
O=vechinv(resgen$vO, nodiag=1, array=1)  # This is n x n x nG.
# double center O
n=nrow(X); nG=nrow(W)
J=diag(n)-(1/n)*matrix(1,n,1)%*%matrix(1,1,n)
B=O
for( k in 1:nG ){
 B[,,k]=-0.5*J%*%O[,,k]^2%*%J
}
Print(O,B, fmt=".2")



res1=indscal( B, nr=2, estm=0, lmax=150, eps=1e-9, print=2 )

res2=sumscal( B, nr=2, estm=0, lmax=150, eps=1e-9, print=2 )


set.seed(1701)
W <- matrix( c( 1,1, 2,1, 1,2 ),,2, byrow=1 )
rownames(W) <- paste("sbj",1:nrow(W),sep=""); colnames(W) <- colnames(X)
theta <- pi/3
T <- matrix(c(cos(theta),sin(theta),-sin(theta),cos(theta)),2,2)
C <- array(0,dim=c(2,2,3))
for( k in 1:nrow(W) ){
 C[,,k] <- T%*%diag(W[k,])%*%t(T)
 E <- 0.05*matrix(rnorm(4),2,2); E <- (E+t(E))/2
 C[,,k] <- C[,,k] + E
}
dimnames(C) <- list(colnames(W),colnames(W),rownames(W))

res <- smscl( C, lmax=100, eps=1e-8, print=2 )







